﻿select * from (select 
	Distinct t.ID, t.Status_ID as Status, t.TicketNR, t.Datum, t.Bezeichnung, a.Suchbegriff as AdressenSuchbegriff, t.LastUpdate, t.Abgeschlossen,
	coalesce((
		select top 1 tb.Beobachter FROM ticket_bearbeiter tb
		where (tb.Gruppe = X.GruppeId or tb.Mitarbeiter = X.MitarbeiterId) and ts.ID = tb.Tickets
		order by tb.Mitarbeiter DESC {{mysqlObserverLimit}}
	), 0) as BeobachterLetzterArbeitsschritt, 
	t.Prioritaet {{charindex}} 
from 
	ticket t
join ticket_bearbeiter tb
	on tb.Ticket = t.ID
join adressen a on a.id = t.Adresse 
left join tickets ts on ts.TICKETID = t.ID
join (
	select 
		m.ID as 'MitarbeiterId',
		gm.Gruppe as 'GruppeId'
	from 
		mitarbeiter m
	left join gruppen_mitarbeiter gm
		on gm.Mitarbeiter = m.ID
	) as X on (x.MitarbeiterId = tb.Mitarbeiter OR x.GruppeId = tb.Gruppe)
where t.Sichtbar = 1 and X.MitarbeiterId = @id and (t.Bezeichnung like @searchText or t.TicketNr like @searchText or a.Suchbegriff like @searchText)
{{statusSQL}}
order by t.LastUpdate DESC 
{{offsetSQL}}
) as subquery {{observerSQL}} {{sortSQL}}