let elements = {
    licenseKey: document.getElementById("license-input"),
    ticketsystem: {
        sqlType: "MSSQL",
        server: document.getElementById("t-server-input"),
        database: document.getElementById("t-database-input"),
        user: document.getElementById("t-user-input"),
        password: document.getElementById("t-password-input"),
        path: document.getElementById("t-path-input"),
    },
    manager: {
        sqlType: "MSSQL",
        server: document.getElementById("m-server-input"),
        database: document.getElementById("m-database-input"),
        user: document.getElementById("m-user-input"),
        password: document.getElementById("m-password-input"),
    },
    serverFinding: {
        serverName : document.getElementById("f-name-input"),
        domain : document.getElementById("f-domain-input"),
        port : document.getElementById("f-port-input"),
    },
    urls: {
        contact: document.getElementById("u-contact-input"),
        impressum: document.getElementById("u-impressum-input"),
        privacy: document.getElementById("u-privacy-input")
    },
    jwt: {
        companyName: document.getElementById("jwt-companyname-input"),
        password: document.getElementById("jwt-password-input")
    }
}

var licenseKeyValue = () => {
    const value =  document.getElementById("license-input").value 
    return {
        success: value != "",
        message: value == "" ? 'Bitte geben Sie den Lizenzschlüssel ein und gehen Sie anschließend auf "Weiter".' : "",
        value: value
    }
}

var ticketValues = () => {
   elements.ticketsystem.sqlType = document.getElementById("t-mssql-toggle").classList.contains("active") ? "MSSQL" : "MYSQL"

    let failedInputs = []

    if(elements.ticketsystem.server.value == "")failedInputs.push(elements.ticketsystem.server)
    if(elements.ticketsystem.database.value == "")failedInputs.push(elements.ticketsystem.database)
    if(elements.ticketsystem.user.value == "")failedInputs.push(elements.ticketsystem.user)
    if(elements.ticketsystem.password.value == "")failedInputs.push(elements.ticketsystem.password)
    if(elements.ticketsystem.path.value == "")failedInputs.push(elements.ticketsystem.path)
    
    setErrorBorder(failedInputs)

    let connectionString = elements.ticketsystem.sqlType == "MSSQL" ?
    `Server=${elements.ticketsystem.server.value};Database=${elements.ticketsystem.database.value};User Id=${elements.ticketsystem.user.value};Password=${elements.ticketsystem.password.value};` :
    `Server=${elements.ticketsystem.server.value};Database=${elements.ticketsystem.database.value};Uid=${elements.ticketsystem.user.value};Pwd=${elements.ticketsystem.password.value};`


    return {
        success: failedInputs.length == 0,
        message: failedInputs.length == 0 ? "" : `Bitte füllen Sie die rot markierten Felder aus und gehen Sie anschließend auf "Weiter".`,
        value: {
            sqlType: elements.ticketsystem.sqlType,
            connectionstring: connectionString,
            ticketDirectoryPath: elements.ticketsystem.path.value
        }
    }
}

var managerValues = ()=>{
    elements.manager.sqlType = document.getElementById("m-mssql-toggle").classList.contains("active") ? "MSSQL" : "MYSQL"
    
    let failedInputs = []

    if(elements.manager.server.value == "")failedInputs.push(elements.manager.server)
    if(elements.manager.database.value == "")failedInputs.push(elements.manager.database)
    if(elements.manager.user.value == "")failedInputs.push(elements.manager.user)
    if(elements.manager.password.value == "")failedInputs.push(elements.manager.password)
    
    if(elements.manager.server.value == "")failedInputs.push(elements.manager.server)
    if(elements.manager.database.value == "")failedInputs.push(elements.manager.database)
    if(elements.manager.user.value == "")failedInputs.push(elements.manager.user)
    if(elements.manager.password.value == "")failedInputs.push(elements.manager.password)

    setErrorBorder(failedInputs)

    let connectionString = elements.manager.sqlType == "MSSQL" ? 
    `Server=${elements.manager.server.value};Database=${elements.manager.database.value};User Id=${elements.manager.user.value};Password=${elements.manager.password.value};` :
    `Server=${elements.manager.server.value};Database=${elements.manager.database.value};Uid=${elements.manager.user.value};Pwd=${elements.manager.password.value};`

    return {
        success: failedInputs.length == 0,
        message: failedInputs.length == 0 ? "" : `Bitte füllen Sie die rot markierten Felder aus und gehen Sie anschließend auf "Weiter".`,
        value: {
            sqlType: elements.manager.sqlType,
            connectionstring: connectionString
        }
    }

}

var serverFindingValues = ()=>{

    let failedInputs = []

    if(elements.serverFinding.serverName.value == "") failedInputs.push(elements.serverFinding.serverName)
    if(elements.serverFinding.port.value == "") failedInputs.push(elements.serverFinding.port)

    setErrorBorder(failedInputs)

    return {
        success: failedInputs.length == 0,
        message: failedInputs.length == 0 ? "" :  `Bitte füllen Sie die rot markierten Felder aus und gehen Sie anschließend auf "Weiter".`,
        value: {
            FindAutomatically: true,
            ServerName: elements.serverFinding.serverName.value,
            DomainName: elements.serverFinding.domain.value, 
            ServerPort: elements.serverFinding.port.value
        }
    }

}

var urlValues = ()=>{
    return {
        success: true,
        value: {
            Kontakt: elements.urls.contact.value,
            ImpressumURL: elements.urls.impressum.value,
            DatenschutzerklaerungURL: elements.urls.privacy.value
        }
    }
}

var jwtValues = ()=>{
    const companyName = document.getElementById("jwt-companyname-input")
    const password = document.getElementById("jwt-password-input")
    let failedInputs = []

    if(companyName.value == "") failedInputs.push(companyName)
    if(password.value == "") failedInputs.push(password)

    setErrorBorder(failedInputs)

    return {
        success: failedInputs == 0,
        message: failedInputs.length == 0 ? "" : `Bitte füllen Sie die rot markierten Felder aus und gehen Sie anschließend auf "Weiter".`,
        value: {
            Issuer: companyName.value,
            Secret: password.value
        }
    }
}

function setData(data){

    //LicenseKey
    elements.licenseKey.value = data.licenseKey

    //Ticket values
    elements.ticketsystem.database.value = data.ticketsystem.database || ""
    elements.ticketsystem.server.value = data.ticketsystem.server || ""
    elements.ticketsystem.password.value = data.ticketsystem.password || ""
    elements.ticketsystem.user.value = data.ticketsystem.user || ""
    elements.ticketsystem.path.value = data.ticketsystem.path || ""
    if(data.ticketsystem.sqlType == "MYSQL") changeToggle("t-mysql-toggle", "t-mssql-toggle")
    else changeToggle("t-mssql-toggle", "t-mysql-toggle")
     

    //Manager values
    elements.manager.database.value = data.manager.database || ""
    elements.manager.server.value = data.manager.server || ""
    elements.manager.password.value = data.manager.password || ""
    elements.manager.user.value = data.manager.user || ""
    if(data.manager.sqlType == "") {
        changeToggle("m-connection-toggle-false", "m-connection-toggle-true")
        document.getElementById("manager-main").style.display = "none"
    }
    if(data.manager.sqlType == "MYSQL") changeToggle("m-mysql-toggle", "m-mssql-toggle") 
    else changeToggle("m-mssql-toggle", "m-mysql-toggle")

    //Serverfinding
    elements.serverFinding.domain.value = data.serverFinding.DomainName || ""
    elements.serverFinding.serverName.value = data.serverFinding.ServerName || ""
    elements.serverFinding.port.value = data.serverFinding.ServerPort || ""
    if(!data.serverFinding.FindAutomatically){
        changeToggle("auto-fing-toggle-false", "auto-fing-toggle-true")
        document.getElementById("finding-main").style.display = "none"
    }

    //URLs
    elements.urls.contact.value = data.urls.kontakt || ""
    elements.urls.impressum.value = data.urls.impressumURL || ""
    elements.urls.privacy.value = data.urls.datenschutzerklaerungURL || ""

    //JWT NOCH 
    elements.jwt.companyName.value = data.jwt.Issuer || ""
    elements.jwt.password.value = data.jwt.Secret || ""
}




var setErrorBorder = (inputs) => inputs.forEach(input => input.classList.add("error-outline"));
document.querySelectorAll("input").forEach(input => input.addEventListener("focus", ()=>input.classList.remove("error-outline")))