//ONLOAD

window.onload = ()=>setConfiguration()

//COMPONENTS
const navItems = {
    nav1: document.getElementById("nav-1"),
    nav2: document.getElementById("nav-2"),
    nav3: document.getElementById("nav-3"),
    nav4: document.getElementById("nav-4"),
    nav5: document.getElementById("nav-5"),
    nav6: document.getElementById("nav-6"),
}

const boxes = {
    license: document.getElementById("license"),
    ticketsystemDb: document.getElementById("ticketsystem-db"),
    managerDb: document.getElementById("manager-db"),
    serverAutomatically: document.getElementById("server-automatically"),
    urls: document.getElementById("urls"),
    jwt: document.getElementById("jwt"),
    success: document.getElementById("success")
}


//BUTTON CLICKS
document.getElementById("license-bttn").addEventListener("click", async (e)=>{
    if(e.path[0].classList.contains("loading")) return
    setLoadingButton(e.path[0])
    const valueValidation = licenseKeyValue()
    if(valueValidation.success){
        if(await post("licensekey", valueValidation.value)) 
            animateInOut(boxes.license, boxes.ticketsystemDb, navItems.nav2)
    } else showError(valueValidation)
    finishLoadingButton(e.path[0])
})
document.getElementById("ticketsystem-db-bttn").addEventListener("click", async (e)=>{
    if(e.path[0].classList.contains("loading")) return
    setLoadingButton(e.path[0])
    const valueValidation = ticketValues();
    if(valueValidation.success){
        if(await post("connection/ticketsystem", valueValidation.value)) 
            animateInOut(boxes.ticketsystemDb, boxes.managerDb, navItems.nav3);
    } else showError(valueValidation);
    finishLoadingButton(e.path[0])
})
document.getElementById("manager-db-bttn").addEventListener("click", async (e)=>{
    if(e.path[0].classList.contains("loading")) return
    if(!document.getElementById("m-connection-toggle-true").classList.contains("active")) {
        animateInOut(boxes.managerDb, boxes.serverAutomatically, navItems.nav4)
        return
    }
    setLoadingButton(e.path[0])
    const valueValidation = managerValues();
    if(valueValidation.success){
        if(await post("connection/manager", valueValidation.value)) 
            animateInOut(boxes.managerDb, boxes.serverAutomatically, navItems.nav4)
    } else showError(valueValidation);
    finishLoadingButton(e.path[0])
})
document.getElementById("server-automatically-bttn").addEventListener("click", async (e)=>{
    if(e.path[0].classList.contains("loading")) return
    if(!document.getElementById("auto-fing-toggle-true").classList.contains("active")) {
        animateInOut(boxes.serverAutomatically, boxes.urls, navItems.nav5)
        return
    }
    setLoadingButton(e.path[0])
    const valueValidation = serverFindingValues();
    if(valueValidation.success){
        if(await post("serverfinding", valueValidation.value)) 
            animateInOut(boxes.serverAutomatically, boxes.urls, navItems.nav5)
    } else showError(valueValidation);
    finishLoadingButton(e.path[0])
})

document.getElementById("urls-bttn").addEventListener("click", async (e)=>{
    if(e.path[0].classList.contains("loading")) return
    setLoadingButton(e.path[0])
    if(await post("urls", urlValues().value)) 
        animateInOut(boxes.urls, boxes.jwt, navItems.nav6)
    finishLoadingButton(e.path[0])
})

document.getElementById("jwt-bttn").addEventListener("click", async (e)=>{
    if(e.path[0].classList.contains("loading")) return
    setLoadingButton(e.path[0])

    const valueValidation = jwtValues();
    if(valueValidation.success){
        if(await post("jwt", valueValidation.value)) 
        animateInOut(boxes.jwt, boxes.success, navItems.nav6)
    } else showError(valueValidation);
    finishLoadingButton(e.path[0])
})



//BACK BUTTONS
document.getElementById("t-back-bttn").addEventListener("click", () => goBack(boxes.ticketsystemDb, boxes.license, navItems.nav1))
document.getElementById("m-back-bttn").addEventListener("click", () => goBack(boxes.managerDb, boxes.ticketsystemDb, navItems.nav2))
document.getElementById("autofinding-back-bttn").addEventListener("click", () => goBack(boxes.serverAutomatically, boxes.managerDb, navItems.nav3))
document.getElementById("url-back-bttn").addEventListener("click", () => goBack(boxes.urls, boxes.serverAutomatically, navItems.nav4))
document.getElementById("jwt-back-bttn").addEventListener("click", () => goBack(boxes.jwt, boxes.urls, navItems.nav5))


//TOGGLES
//Ticketsystem
document.getElementById("t-mssql-toggle").addEventListener("click", ()=>changeToggle("t-mssql-toggle", "t-mysql-toggle"))
document.getElementById("t-mysql-toggle").addEventListener("click", ()=>changeToggle("t-mysql-toggle", "t-mssql-toggle"))

//ManagerConnection
document.getElementById("m-connection-toggle-true").addEventListener("click", ()=>{
    changeToggle("m-connection-toggle-true", "m-connection-toggle-false")
    document.getElementById("manager-main").style.display = "block"
})
document.getElementById("m-connection-toggle-false").addEventListener("click", ()=>{
    changeToggle("m-connection-toggle-false", "m-connection-toggle-true")
    document.getElementById("manager-main").style.display = "none"
})

//Manager SQL-Type
document.getElementById("m-mssql-toggle").addEventListener("click", ()=>changeToggle("m-mssql-toggle", "m-mysql-toggle"))
document.getElementById("m-mysql-toggle").addEventListener("click", ()=>changeToggle("m-mysql-toggle", "m-mssql-toggle"))

//Automatically find
document.getElementById("auto-fing-toggle-true").addEventListener("click", ()=>{
    changeToggle("auto-fing-toggle-true", "auto-fing-toggle-false")
    document.getElementById("finding-main").style.display = "block"
})
document.getElementById("auto-fing-toggle-false").addEventListener("click", ()=>{
    changeToggle("auto-fing-toggle-false", "auto-fing-toggle-true")
    document.getElementById("finding-main").style.display = "none"
})


//MAIN FUNCTIONS
function animateInOut(componentOut, componentIn, activeNav ){
    componentOut.classList.replace( componentOut.classList.contains("animate-in") ? "animate-in" : "animate-back-in", "animate-out")
    componentIn.classList.remove("animate-back-out")
    componentIn.classList.add("animate-in")
    activeNav.classList.add("active")
}

function goBack(componentOut, componentIn, activeNav ){
    componentOut.classList.replace(componentOut.classList.contains("animate-back-in") ? "animate-back-in" : "animate-in", "animate-back-out")
    componentIn.classList.remove("animate-out")
    componentIn.classList.add("animate-back-in")
    Object.entries(navItems).forEach(item => {
        if(!(+item[1].id.replace("nav-", "") <= +activeNav.id.replace("nav-", ""))) item[1].classList.remove("active")
    })
}

function changeToggle(activeId, inactiveId){
    document.getElementById(activeId).classList.add("active")
    document.getElementById(inactiveId).classList.remove("active")
}

function setLoadingButton(button){
    button.innerHTML = '<svg aria-hidden="true" focusable="false" data-prefix="fas" data-icon="spinner-third" class="svg-inline--fa fa-spinner-third" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path fill="currentColor" d="M283.2 65.92C267.6 63.69 256 50.32 256 34.52c0-19.38 17.19-34.69 36.38-31.95C416.4 20.29 512 127.2 512 256c0 33.38-6.544 65.26-18.27 94.49c-7.162 17.86-28.85 24.87-45.56 15.32c-13.74-7.854-19.62-24.53-13.75-39.23C443.2 304.7 448 280.9 448 256C448 159.4 376.3 79.18 283.2 65.92z"></path></svg>'
    button.classList.add("loading")
}

function finishLoadingButton(button){
    button.innerHTML = "Weiter"
    button.classList.remove("loading")
}

function showError(validationBody){
    let errorBox = document.createElement("div")
    errorBox.classList.add("error")
    errorBox.innerHTML = `
        <svg aria-hidden="true" focusable="false" data-prefix="fas" data-icon="xmark" class="svg-inline--fa fa-xmark" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 320 512"><path fill="currentColor" d="M310.6 361.4c12.5 12.5 12.5 32.75 0 45.25C304.4 412.9 296.2 416 288 416s-16.38-3.125-22.62-9.375L160 301.3L54.63 406.6C48.38 412.9 40.19 416 32 416S15.63 412.9 9.375 406.6c-12.5-12.5-12.5-32.75 0-45.25l105.4-105.4L9.375 150.6c-12.5-12.5-12.5-32.75 0-45.25s32.75-12.5 45.25 0L160 210.8l105.4-105.4c12.5-12.5 32.75-12.5 45.25 0s12.5 32.75 0 45.25l-105.4 105.4L310.6 361.4z"></path></svg>
        <div>
            <h4>Fehler</h4>
            <p>${validationBody.message}</p>
        </div>
    `
    document.body.appendChild(errorBox)
    setTimeout(() => {
        errorBox.classList.add("hideError")
        setTimeout(() => errorBox.remove(), 500);
    }, 5000);
    return
}

async function post(route, data){
    return new Promise(resolve=>{
        fetch(`/api/serverConfig/${route}`,{
            method: "POST",
            headers: {
                'Content-Type': 'application/json'
            },
            body: JSON.stringify(data)
        })
        .then(async response => {
            if(response.status == 200) resolve(true)
            else if(response.status == 400){
                showError({message: "Daten können nicht von externen Clients geändert werden. Bitte führen Sie diese Aktion auf dem Server aus."})
                resolve(false)
            }
            else {
                showError({message: (await response.json()).message})
                resolve(false)
            };
        })
        .catch((e) => {
            console.error(e)
            showError({message: "Ein Unbekannter Fehler ist aufgetreten"})
            resolve(false)
        })
    })
}

async function setConfiguration(){
    fetch("/api/serverConfig", {
        method: "GET",
        headers: {
            "Content-Type": "application/json"
        }
    })
    .then(async response => {
        if(response.status == 200){
            setData(await response.json())
        }else if(response.status == 400){
            document.body.innerHTML = `
            <div id="no-access" class="box">
                <svg aria-hidden="true" focusable="false" data-prefix="fas" data-icon="triangle-exclamation" class="svg-inline--fa fa-triangle-exclamation" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path fill="currentColor" d="M506.3 417l-213.3-364c-16.33-28-57.54-28-73.98 0l-213.2 364C-10.59 444.9 9.849 480 42.74 480h426.6C502.1 480 522.6 445 506.3 417zM232 168c0-13.25 10.75-24 24-24S280 154.8 280 168v128c0 13.25-10.75 24-23.1 24S232 309.3 232 296V168zM256 416c-17.36 0-31.44-14.08-31.44-31.44c0-17.36 14.07-31.44 31.44-31.44s31.44 14.08 31.44 31.44C287.4 401.9 273.4 416 256 416z"></path></svg>
                <h2>Kein Zugriff von externen Geräten!</h2>
                <p>Die Konfigurationsseite kann nur vom Server aus aufgerufen werden. <br> <br> <b>http://localhost:{port}/setup</b></p>
                <button><a href="/">Zur Website</a></button>
            </div>
            `
        }else{
            const body = await response.json()
            showError({message: body.message || "Ein unbekannter Fehler ist aufgetreten"})
        }
    })
}



