// service-worker.js

const CACHE_NAME = 'ticketsystem-v170-build-2';

// Ressourcen, die im Cache gespeichert werden sollen
const urlsToCache = [
  '/',
  '/index.html',
  '/styles.css',
  '/main.js',
  // Weitere Ressourcen, die gecacht werden sollen
];

self.addEventListener('install', (event) => {
  event.waitUntil(
    caches.open(CACHE_NAME).then((cache) => {
      return cache.addAll(urlsToCache);
    })
  );
});

self.addEventListener('fetch', (event) => {
  event.respondWith(
    caches.match(event.request).then((response) => {
      return response || fetch(event.request);
    })
  );
});

self.addEventListener('activate', (event) => {
  event.waitUntil(
    caches.keys().then((cacheNames) => {
      return Promise.all(
        cacheNames.map((cacheName) => {
          if (cacheName !== CACHE_NAME) {
            return caches.delete(cacheName);
          }
        })
      );
    })
  );
});
